#include <stdio.h>
#include <stdlib.h>

int gettoken(char *token);
void error(char *token,char *expected);

struct literalpool
{
  char name[30];
  int type;
};

int line;
FILE *out2,*out,*tmp;
char widgets[8000][100];
char *widget_types;
int widgetptr;
char tokenpush[255];
int tokentypepush;
int poolptr;
int indent=0;
struct literalpool mypool[500];

void push(int tokentype,char *token)
{
  strcpy(tokenpush,token);
  tokentypepush=tokentype;
}

void autoindent(FILE *outfile)
{
int r;

  for (r=0; r<indent; r++)
  { fprintf(outfile,"  "); }
}

int search_gui(char *token)
{
int r;

  for (r=0; r<widgetptr; r++)
  {
    if (strcasecmp(widgets[r],token)==0)
    { return r; }
  }

  return -1;
}

void eval_expression()
{
char token[255];
int tokentype;
int count=0;
int string=1;

  while((tokentype=gettoken(token))!=5)
  {
    if (tokentype==10 || tokentype==11)
    {
      token[0]='\"';
      token[strlen(token)-1]='\"';

      if (count==0)
      { autoindent(out2); fprintf(out2,"strcpy(tmpstring,%s);\n",token); }
      	else
      { autoindent(out2); fprintf(out2,"strcat(tmpstring,%s);\n",token); }

      count++;
    }
      else
    if (strcmp(token,"&")==0)
    { continue; }
      else
    if (tokentype==7)
    { string=0; }
  }
}

void eval_text(char *guitoken, int w)
{
char token[255];
int tokentype;

  tokentype=gettoken(token);

  if (strcmp(token,"=")!=0)
  { error(token,"="); }

  eval_expression();
  autoindent(out2);
  fprintf(out2,"gtk_text_backward_delete(GTK_TEXT(%s),GTK_TEXT(%s)->text_end-GTK_TEXT(%s)->gap_size);\n",guitoken,guitoken,guitoken);
  autoindent(out2);
  fprintf(out2,"gtk_text_insert(GTK_TEXT(%s),NULL,NULL,NULL,tmpstring,-1);\n",guitoken);
}

void eval_gui(char *guitoken)
{
char token[255];
int tokentype;
int w;

  w=search_gui(token);

  tokentype=gettoken(token);

  if (strcmp(token,".")!=0)
  { error(token,"."); }

  tokentype=gettoken(token);

  if (strcasecmp(token,"Text")==0)
  { eval_text(guitoken,w); }
}

void eval_event(char *token, char *event)
{
  if (strcasecmp(event,"Click")==0)
  {
    fprintf(tmp,"  gtk_signal_connect(GTK_OBJECT(%s),\"clicked\",GTK_SIGNAL_FUNC(%s_%s),NULL);\n",token,token,event);
    fprintf(out2,"\nvoid %s_%s()\n{\nchar tmpstring[1024];\n",token,event);
  }
}

void parse_sub()
{
char token[255];
int tokentype;
int r;

  tokentype=gettoken(token);

  indent++;
  r=0;
  while(token[r]!=0)
  {
    if (token[r]=='_')
    {
      token[r]=0;
      eval_event(token,&token[r+1]);
      break;
    }
    r++;
  }

  tokentype=gettoken(token);

  if (strcmp(token,"(")==0)
  { tokentype=gettoken(token); }
    else
  { push(tokentype,token); }

  while((tokentype=gettoken(token))!=0)
  {
    if (search_gui(token)!=-1)
    { eval_gui(token); }
      else
    if (strcasecmp(token,"End")==0) break;
      else
    if (tokentype==5)
    { continue; }
      else
    { while ((tokentype=gettoken(token))!=5); }
  }

  tokentype=gettoken(token);
  if (strcasecmp(token,"Sub")!=0)
  { error(token,"Sub"); }

  indent--;
  fprintf(out2,"}\n");
}

void parse_dim(FILE *outfile)
{
char token[255];
int tokentype;

  tokentype=gettoken(token);   
  strcpy(mypool[poolptr].name,token);

  tokentype=gettoken(token);   
  if (strcasecmp(token,"As")!=0)
  { error(token,"As"); }

  tokentype=gettoken(token);   

  if (strcasecmp(token,"Integer")==0)
  {
    fprintf(outfile,"int %s;\n",mypool[poolptr].name);
    mypool[poolptr++].type=1;
  }
    else
  if (strcasecmp(token,"String")==0)
  {
    fprintf(outfile,"char %s[1024];\n",mypool[poolptr].name);
    mypool[poolptr++].type=2;
  }
}



