#include <stdio.h>
#include <stdlib.h>

#include "generate.h"

#define SCALE 15

struct literalpool
{
  char name[30];
  int type;
};

/* THIS CODE IS NOT GPL.  COPYRIGHT 1999 Michael Kohn
   Please read the README for more info */

char tokenpush[255]={ 0 };
int tokentypepush=0;
FILE *in,*out,*out2;
FILE *tmp;
int pushback=-1;
char widgets[8000][100];
char widget_types[8000];
int widget_parent[8000];
int widgetptr=0;
int column;
int line;
struct literalpool mypool[500];
int poolptr=0;

void parse_Form();
void parse_CommandButton(int parent);
void parse_TextBox(int parent);
void parse_CheckBox(int parent);
void parse_Label(int parent);
void parse_ListBox(int parent);
void parse_ComboBox(int parent);

void error(char token[255],char expected[30])
{
  printf("Parse Error: Expected '%s' and got '%s' on line %d",expected,token,line);
}

int gettoken(char *token)
{
int ptr=0,tokentype=2;
int ch,sflag=0,r=0;
int quote=0;

  if (tokenpush[0]!=0)
  {
    strcpy(token,tokenpush);
    tokenpush[0]=0;
    return tokentypepush;
  }

  token[1]=0;

  while(1)
  {
    if (pushback!=-1)
    { ch=pushback; pushback=-1; }
      else
    { ch=getc(in); }

    column++;

    if (ch==EOF) break;

    if (quote=='\'' && sflag!=1)
    {
      if (ch=='\n' || ch=='\r')
      { 
        token[0]='/';
        for (r=ptr; r>0; r--)
        { token[r]=token[r-1]; }
        token[ptr+1]='\n';
        token[ptr+2]=0;
        return 15;
      }
    }

    if (sflag==1)
    {
      if (ch!=quote)
      {
	pushback=ch;
        token[ptr]=0;
	if (ch=='\"') return 10;
	return 11;
      }
    }

    if (ch=='\"' || ch=='\'')
    {
      if (ptr==0)
      { quote=ch; }
	else
      if (quote==ch)
      {
	if (token[ptr-1]==ch)
        {
	  if (ptr==1)
	  {
	    ch=getc(in);
            pushback=ch;
	    if (ch!=quote)
	    {
	      token[ptr]=quote;
	      token[ptr+1]=0;
	      if (quote=='\'') return 11; else return 10;
	    }
	    sflag=1;
	  }
	    else
          { token[ptr-1]='\\'; }
        }
	  else
        { sflag=1; }
      }
    }

    if (quote!=0)
    {
      token[ptr++]=ch;
      continue;
    }

    if ((ch=='>' && ptr==1) && token[ptr-1]=='%')
    { token[1]='>'; token[2]=0; return 6; }

    if (sflag==2)
    {
      if (ch=='=' || (ch=='>' && token[0]=='<'))
      { token[1]=ch; token[2]=0; }
	else
      { pushback=ch; token[1]=0; }
      return 8;
    }

    if (ch=='>' || ch=='<')
    {
      if (ptr!=0)
      { pushback=ch; token[ptr]=0; break; }
	else
      { sflag=2; tokentype=8; }
    }

    if (ch=='(' || ch==')')
    { 
      if (ptr!=0)
      { pushback=ch; token[ptr]=0; break; }
	else
      { token[0]=ch; return 12; }
    }

    if (ch=='%')
    {
      if (ptr!=0)
      { pushback=ch; token[ptr]=0; break; }
    }

    if (ch=='=')
    {
      if (ptr!=0)
      { pushback=ch; token[ptr]=0; break; }
	else
      { token[0]=ch; return 8; }
    }

    if (ch=='&')
    {
      if (ptr!=0)
      {
	if (ptr==1 && (ch=='h' || ch=='H'))
        {
	  token[0]='0';
	  token[1]='x';
	  tokentype=1;
        }
	  else
	{ pushback=ch; token[ptr]=0; break; }
      }
	else
      { token[0]=ch; return 9; }
    }

    if (ch==':')
    {
      if (ptr!=0)
      { pushback=ch; token[ptr]=0; break; }
	else
      { token[0]=ch; return 13; }
    }

    if (ch==',')
    {
      if (ptr!=0)
      { pushback=ch; token[ptr]=0; break; }
	else
      { token[0]=ch; return 16; }
    }

    if (ch=='.')
    {
      if (ptr!=0)
      { pushback=ch; token[ptr]=0; break; }
	else
      { token[0]=ch; return 14; }
    }

    if ((ch=='+' || ch=='-') || (ch=='*' || ch=='/'))
    {
      if (ptr==0)
      { token[0]=ch; token[1]=0; return 7; }
	else
      {
	pushback=ch;
        break;
      }
    }

    if (ch=='_')
    {
      if (ptr==0)
      {
	token[0]=ch;
	while ((ch=getc(in))!=EOF)
        {
	  if (ch=='\n' || ch=='\r')
          {
            line++;
	    r=getc(in);
            if (r=='\r' || r=='\n')
            { if (ch==r) pushback=r; }
	      else
	    { pushback=r; }
	    return 3;
	  }
        }
        return 0;
      }
	else
      if (tokentype==2)
      { token[ptr++]=ch; continue; }
	else
      { pushback=ch; break; }
    }

    if (ch=='\r' || ch=='\n')
    {
      if (ptr==0)
      {
        token[0]='\n';
        column=0;
        line++;
	r=getc(in);
        if (r=='\r' || r=='\n')
        { if (ch==r) pushback=r; }
	  else
	{ pushback=r; }
        return 5;
      }
	else
      { pushback=ch; break; }
    }

    if (ch==' ' || ch=='\t')
    {
      if (ptr==0)
      { /* putc(ch,out); */ continue; }
	else
      {
	pushback=ch;
        token[ptr]=0;
	return tokentype;
      }
    }

    if (tokentype==1)
    {
      if (ch<'0' || ch>'9')
      { pushback=ch; break; }
    }

    if (ch>='0' && ch<='9')
    {
      if (ptr==0)
      { tokentype=1; }
    }

    token[ptr++]=(char)ch;
  }

  if (ptr==0) return 0;

  token[ptr]=0;
  return tokentype;
}

int getvalue()
{
char token[255];
int tokentype;
int i;

  tokentype=gettoken(token);

  if (strcmp(token,"=")!=0)
  { printf("Umm.. what the flock?.. I got a %s when i want frocking '='\n",token); } 

  tokentype=gettoken(token);

  i=atoi(token);
  return i;
}

void parse_Component(int currwidget)
{
char token[255];
int tokentype;

  tokentype=gettoken(token);

  if (strcasecmp(token,"vb")!=0)
  { printf("Ack (comp)!  What the hell does this mean: '%s'\n",token); }

  tokentype=gettoken(token);

  if (strcasecmp(token,".")!=0)
  { printf("What the hell? (comp)  I expected a '.'!  I got this crap: '%s'\n",token); }

  tokentype=gettoken(token);

  if (strcasecmp(token,"Form")==0)
  { parse_Form(); }
    else
  if (strcasecmp(token,"TextBox")==0)
  { parse_TextBox(currwidget); }
    else
  if (strcasecmp(token,"CommandButton")==0)
  { parse_CommandButton(currwidget); }
    else
  if (strcasecmp(token,"CheckBox")==0)
  { parse_CheckBox(currwidget); }
    else
  if (strcasecmp(token,"Label")==0)
  { parse_Label(currwidget); }
    else
  if (strcasecmp(token,"ListBox")==0)
  { parse_ListBox(currwidget); }
    else
  if (strcasecmp(token,"ComboBox")==0)
  { parse_ComboBox(currwidget); }
    else
  { while ((tokentype=gettoken(token))!=5); }
}

void parse_Form()
{
char token[255];
char name[255];
int tokentype;
int height=-1,width=-1;
int left=-1,top=-1;
int currwidget;

  tokentype=gettoken(token);

  fprintf(out2,"GtkWidget *%s;\n",token);
  fprintf(out2,"GtkWidget *%s_fix;\n",token);
  strcpy(name,token);
  currwidget=widgetptr;
  widget_types[widgetptr]=1;
  widget_parent[widgetptr]=-1;
  strcpy(widgets[widgetptr++],token);

  fprintf(tmp,"  %s=gtk_window_new(GTK_WINDOW_TOPLEVEL);\n",name);
  fprintf(tmp,"  %s_fix=gtk_fixed_new();\n",name);

  while((tokentype=gettoken(token))!=0)
  {
    if (tokentype==5) continue;

    if (strcasecmp(token,"End")==0)
    { break; }
      else
    if (strcasecmp(token,"ClientHeight")==0)
    { height=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"ClientWidth")==0)
    { width=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"ClientTop")==0)
    { top=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"ClientLeft")==0)
    { left=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Caption")==0)
    {
      tokentype=gettoken(token);
      if (strcmp(token,"=")!=0)
      { printf("Damnit.. I expected an '=' and got %s\n",token); }
      tokentype=gettoken(token);
      fprintf(tmp,"  gtk_window_set_title(GTK_WINDOW(%s),%s);\n",name,token);
    }
      else
    if (strcasecmp(token,"Begin")==0)
    { parse_Component(currwidget); }
      else
    { while ((tokentype=gettoken(token))!=5); }
  }

  if (height!=-1 && width!=-1)
  {
    fprintf(tmp,"  gtk_widget_set_usize(%s,%d,%d);\n",name,width,height);
  } 

/*
  if (left!=-1 && top!=-1)
  {
    fprintf(tmp,"  gtk_widget_set_uposition(%s,%d,%d);\n",name,left,top);
  } 
*/

  while ((tokentype=gettoken(token))!=5);
  fprintf(tmp,"\n");
}

void parse_ListBox(int parent)
{
char token[255];
char name[255];
int tokentype;
int height=-1,width=-1;
int left=-1,top=-1;

  tokentype=gettoken(token);

  strcpy(name,token);
  fprintf(out2,"GtkWidget *%s;\n",token);
  widget_types[widgetptr]=2;
  widget_parent[widgetptr]=parent;
  strcpy(widgets[widgetptr++],token);

  fprintf(tmp,"  %s=gtk_text_new(NULL,NULL);\n",token);
  fprintf(tmp,"  gtk_text_set_editable(GTK_TEXT(%s),1);\n",token);

  while((tokentype=gettoken(token))!=0)
  {
    if (tokentype==5) continue;

    if (strcasecmp(token,"End")==0)
    { break; }
      else
    if (strcasecmp(token,"Height")==0)
    { height=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Width")==0)
    { width=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Top")==0)
    { top=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Left")==0)
    { left=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Text")==0)
    {
      tokentype=gettoken(token);
      if (strcmp(token,"=")!=0)
      { printf("Damnit.. I expected an '=' and got %s\n",token); }
      tokentype=gettoken(token);
      fprintf(tmp,"  gtk_text_insert(GTK_TEXT(%s),NULL,
                     &%s->style->black,NULL,%s,-1);\n",name,name,token);
    }
      else
    { while ((tokentype=gettoken(token))!=5); }
  }

  if (height!=-1 && width!=-1)
  {
    fprintf(tmp,"  gtk_widget_set_usize(%s,%d,%d);\n",name,width,height);
  } 

  if (left!=-1 && top!=-1)
  {
    fprintf(tmp,"  gtk_widget_set_uposition(%s,%d,%d);\n",name,left,top);
  } 

  while ((tokentype=gettoken(token))!=5);
  fprintf(tmp,"\n");

}

void parse_ComboBox(int parent)
{
char token[255];
char name[255];
int tokentype;
int height=-1,width=-1;
int left=-1,top=-1;

  tokentype=gettoken(token);

  strcpy(name,token);
  fprintf(out2,"GtkWidget *%s;\n",token);
  widget_types[widgetptr]=2;
  widget_parent[widgetptr]=parent;
  strcpy(widgets[widgetptr++],token);

  fprintf(tmp,"  %s=gtk_text_new(NULL,NULL);\n",token);
  fprintf(tmp,"  gtk_text_set_editable(GTK_TEXT(%s),1);\n",token);

  while((tokentype=gettoken(token))!=0)
  {
    if (tokentype==5) continue;

    if (strcasecmp(token,"End")==0)
    { break; }
      else
    if (strcasecmp(token,"Height")==0)
    { height=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Width")==0)
    { width=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Top")==0)
    { top=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Left")==0)
    { left=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Text")==0)
    {
      tokentype=gettoken(token);
      if (strcmp(token,"=")!=0)
      { printf("Damnit.. I expected an '=' and got %s\n",token); }
      tokentype=gettoken(token);
      fprintf(tmp,"  gtk_text_insert(GTK_TEXT(%s),NULL,
                     &%s->style->black,NULL,%s,-1);\n",name,name,token);
    }
      else
    { while ((tokentype=gettoken(token))!=5); }
  }

  if (height!=-1 && width!=-1)
  {
    fprintf(tmp,"  gtk_widget_set_usize(%s,%d,%d);\n",name,width,height);
  } 

  if (left!=-1 && top!=-1)
  {
    fprintf(tmp,"  gtk_widget_set_uposition(%s,%d,%d);\n",name,left,top);
  } 

  while ((tokentype=gettoken(token))!=5);
  fprintf(tmp,"\n");

}

void parse_TextBox(int parent)
{
char token[255];
char name[255];
int tokentype;
int height=-1,width=-1;
int left=-1,top=-1;

  tokentype=gettoken(token);

  strcpy(name,token);
  fprintf(out2,"GtkWidget *%s;\n",token);
  widget_types[widgetptr]=2;
  widget_parent[widgetptr]=parent;
  strcpy(widgets[widgetptr++],token);

  fprintf(tmp,"  %s=gtk_text_new(NULL,NULL);\n",token);
  fprintf(tmp,"  gtk_text_set_editable(GTK_TEXT(%s),1);\n",token);

  while((tokentype=gettoken(token))!=0)
  {
    if (tokentype==5) continue;

    if (strcasecmp(token,"End")==0)
    { break; }
      else
    if (strcasecmp(token,"Height")==0)
    { height=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Width")==0)
    { width=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Top")==0)
    { top=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Left")==0)
    { left=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Text")==0)
    {
      tokentype=gettoken(token);
      if (strcmp(token,"=")!=0)
      { printf("Damnit.. I expected an '=' and got %s\n",token); }
      tokentype=gettoken(token);
      fprintf(tmp,"  gtk_text_insert(GTK_TEXT(%s),NULL,
                     &%s->style->black,NULL,%s,-1);\n",name,name,token);
    }
      else
    { while ((tokentype=gettoken(token))!=5); }
  }

  if (height!=-1 && width!=-1)
  {
    fprintf(tmp,"  gtk_widget_set_usize(%s,%d,%d);\n",name,width,height);
  } 

  if (left!=-1 && top!=-1)
  {
    fprintf(tmp,"  gtk_widget_set_uposition(%s,%d,%d);\n",name,left,top);
  } 

  while ((tokentype=gettoken(token))!=5);
  fprintf(tmp,"\n");

}

void parse_CommandButton(int parent)
{
char token[255];
char name[255];
char Caption[255];
int tokentype;
int height=-1,width=-1;
int left=-1,top=-1;

  strcpy(Caption,"\"\"");

  tokentype=gettoken(token);

  fprintf(out2,"GtkWidget *%s;\n",token);
  strcpy(name,token);
  widget_types[widgetptr]=3;
  widget_parent[widgetptr]=parent;
  strcpy(widgets[widgetptr++],token);

  while((tokentype=gettoken(token))!=0)
  {
    if (tokentype==5) continue;
    if (strcasecmp(token,"End")==0)
    { break; }
      else
    if (strcasecmp(token,"Height")==0)
    { height=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Width")==0)
    { width=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Top")==0)
    { top=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Left")==0)
    { left=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Caption")==0)
    {
      tokentype=gettoken(token);
      if (strcmp(token,"=")!=0)
      { printf("Damnit.. I expected an '=' and got %s\n",token); }
      tokentype=gettoken(token);
      strcpy(Caption,token);
    }
      else
    { while ((tokentype=gettoken(token))!=5); }
  }

  fprintf(tmp,"  %s=gtk_button_new_with_label(%s);\n",name,Caption);

  if (height!=-1 && width!=-1)
  {
    fprintf(tmp,"  gtk_widget_set_usize(%s,%d,%d);\n",name,width,height);
  } 

  if (left!=-1 && top!=-1)
  {
    fprintf(tmp,"  gtk_widget_set_uposition(%s,%d,%d);\n",name,left,top);
  } 

  while ((tokentype=gettoken(token))!=5);
  fprintf(tmp,"\n");
}

void parse_CheckBox(int parent)
{
char token[255];
char name[255];
char Caption[255];
int tokentype;
int height=-1,width=-1;
int left=-1,top=-1;

  tokentype=gettoken(token);

  fprintf(out2,"GtkWidget *%s;\n",token);
  strcpy(name,token);
  widget_types[widgetptr]=4;
  widget_parent[widgetptr]=parent;
  strcpy(widgets[widgetptr++],token);

  while((tokentype=gettoken(token))!=0)
  {
    if (tokentype==5) continue;
    if (strcasecmp(token,"End")==0)
    { break; }
      else
    if (strcasecmp(token,"Height")==0)
    { height=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Width")==0)
    { width=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Top")==0)
    { top=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Left")==0)
    { left=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Caption")==0)
    {
      tokentype=gettoken(token);
      if (strcmp(token,"=")!=0)
      { printf("Damnit.. I expected an '=' and got %s\n",token); }
      tokentype=gettoken(token);
      strcpy(Caption,token);
    }
      else
    { while ((tokentype=gettoken(token))!=5); }
  }

  fprintf(tmp,"  %s=gtk_check_button_new_with_label(%s);\n",name,Caption);

  if (height!=-1 && width!=-1)
  {
    fprintf(tmp,"  gtk_widget_set_usize(%s,%d,%d);\n",name,width,height);
  } 

  if (left!=-1 && top!=-1)
  {
    fprintf(tmp,"  gtk_widget_set_uposition(%s,%d,%d);\n",name,left,top);
  } 

  while ((tokentype=gettoken(token))!=5);
  fprintf(tmp,"\n");
}

void parse_Label(int parent)
{
char token[255];
char name[255];
char Caption[255];
int tokentype;
int height=-1,width=-1;
int left=-1,top=-1;

  tokentype=gettoken(token);

  fprintf(out2,"GtkWidget *%s;\n",token);
  strcpy(name,token);
  widget_types[widgetptr]=5;
  widget_parent[widgetptr]=parent;
  strcpy(widgets[widgetptr++],token);

  while((tokentype=gettoken(token))!=0)
  {
    if (tokentype==5) continue;
    if (strcasecmp(token,"End")==0)
    { break; }
      else
    if (strcasecmp(token,"Height")==0)
    { height=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Width")==0)
    { width=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Top")==0)
    { top=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Left")==0)
    { left=getvalue()/SCALE; }
      else
    if (strcasecmp(token,"Caption")==0)
    {
      tokentype=gettoken(token);
      if (strcmp(token,"=")!=0)
      { printf("Damnit.. I expected an '=' and got %s\n",token); }
      tokentype=gettoken(token);
      strcpy(Caption,token);
    }
      else
    { while ((tokentype=gettoken(token))!=5); }
  }

  fprintf(tmp,"  %s=gtk_label_new(%s);\n",name,Caption);

  if (height!=-1 && width!=-1)
  {
    fprintf(tmp,"  gtk_widget_set_usize(%s,%d,%d);\n",name,width,height);
  } 

  if (left!=-1 && top!=-1)
  {
    fprintf(tmp,"  gtk_widget_set_uposition(%s,%d,%d);\n",name,left,top);
  } 

  while ((tokentype=gettoken(token))!=5);
  fprintf(tmp,"\n");
}

void parse()
{
char token[255];
int tokentype;

  while((tokentype=gettoken(token))!=0)
  {
    if (strcasecmp(token,"VERSION")==0)
    {
      printf("Visual Basic Version (like we really care): ");
      while((tokentype=gettoken(token))!=5)
      {
	printf("%s",token);
      }
      printf("\n");
    }
      else
    if (strcasecmp(token,"Begin")==0)
    { parse_Component(-1); }
      else
    if (strcasecmp(token,"Private")==0 || strcasecmp(token,"Public")==0)
    {
      tokentype=gettoken(token);
      if (strcasecmp(token,"Sub")==0)
      { parse_sub(); } 
    }
      else
    if (strcasecmp(token,"Sub")==0)
    { parse_sub(); }
      else
    if (strcasecmp(token,"Dim")==0)
    { parse_dim(out2); }
      else
    if (strcasecmp(token,"Attribute")==0)
    { while((tokentype=gettoken(token))!=5); }
  }
}

int main(int argc, char *argv[])
{
char infile[255];
char outfile[255];
char tmpfile2[255];
char tmpfile[255];
char buffer[1024];
int r;

  if (argc<2)
  {
    printf("Usage: vb2c <infile>\n");
    exit(1);
  }

  strcpy(infile,argv[1]);
  strcpy(outfile,argv[1]);
  strcpy(tmpfile,argv[1]);
  strcpy(tmpfile2,argv[1]);

  strcat(infile,".frm");
  strcat(outfile,".c");
  strcat(tmpfile,".tmp");
  strcat(tmpfile2,"2.tmp");

  in=fopen(infile,"r");
 
  if (in==0)
  { printf("Cannot open %s for reading.\n",infile); exit(1); } 

  out=fopen(tmpfile2,"w");

  if (out==0)
  { printf("Cannout open %s for writing.\n",tmpfile2); exit(1); }

  out2=fopen(outfile,"w");

  if (out==0)
  { printf("Cannout open %s for writing.\n",outfile); exit(1); }
  tmp=fopen(tmpfile,"w");

  if (tmp==0)
  { printf("Cannout open %s for writing.\n",tmpfile); exit(1); }

  printf("------------------------------------------------------\n");
  printf("VisualBasic to C/GTK converter v0.02/March 27, 1999\nCopyright 1999 Michael Kohn\n");
  printf("LICENSE: You may not use this for commercial purposes.\n");
  printf("------------------------------------------------------\n\n");
  printf("Infile: %s\nOutfile: %s\n\n",infile,outfile);

  fprintf(out2,"#include <stdio.h>\n#include <stdlib.h>\n");
  fprintf(out2,"#include <gtk/gtk.h>\n\n");

  fprintf(out,"\nvoid destroy(GtkWidget *widget, gpointer data)\n{\n");
  fprintf(out,"  gtk_main_quit();\n}\n\n");
  fprintf(out,"int main(int argc, char *argv[])\n{\n");

  parse();

  fclose(tmp);

  tmp=fopen(tmpfile,"r");

  if (tmp==0)
  { printf("Cannout open %s for reading.\n",tmpfile); exit(1); }

  fprintf(out,"\n  gtk_init(&argc, &argv);\n\n");

  while(fgets(buffer,1024,tmp)!=0)
  { fprintf(out,"%s",buffer); }

  for (r=0; r<widgetptr; r++)
  {
/*    if (widget_types[r]==1) continue; */

    if (widget_parent[r]==-1)
    { fprintf(out,"  gtk_container_add(GTK_CONTAINER(%s),%s_fix);\n",widgets[r],widgets[r]); }
      else
    { fprintf(out,"  gtk_container_add(GTK_CONTAINER(%s_fix),%s);\n",widgets[widget_parent[r]],widgets[r]); }
  }

  fprintf(out,"\n");

  for (r=0; r<widgetptr; r++)
  {
    if (widget_types[r]==1)  
    { fprintf(out,"  gtk_widget_show(%s_fix);\n",widgets[r]); }

    fprintf(out,"  gtk_widget_show(%s);\n",widgets[r]);
  }

  for (r=0; r<widgetptr; r++)
  {
    if (widget_types[r]==1)  
    {
      fprintf(out,"  gtk_signal_connect(GTK_OBJECT(%s),\"delete_event\",GTK_SIGNAL_FUNC(destroy),NULL);\n",widgets[r]);
      fprintf(out,"  gtk_signal_connect(GTK_OBJECT(%s),\"destroy\",GTK_SIGNAL_FUNC(destroy),NULL);\n",widgets[r]);
    }
  }

  fprintf(out,"\n  gtk_main();\n  return 0;\n}\n\n");

  fclose(in);
  fclose(out);

  tmp=fopen(tmpfile2,"r");

  if (tmp==0)
  { printf("Cannout open %s for reading.\n",tmpfile2); exit(1); }

  fprintf(out,"\n  gtk_init(&argc, &argv);\n\n");

  while(fgets(buffer,1024,tmp)!=0)
  { fprintf(out2,"%s",buffer); }

  fclose(tmp);
  fclose(out2);
}



